uniform sampler2D fboTexture;
uniform float timer;
uniform float noise;
uniform float staticNoiseAmmount;
uniform float fadeLevel;

void main() {
	vec2 texCoord = gl_TexCoord[0].st;
	vec4 BW = vec4(0.3,0.59,0.11,0);
	vec4 Sepia = vec4(1.0,0.8,0.6,1);
	float brightness;
	float staticNoise = fract(sin(timer+dot(gl_TexCoord[0].st,vec2(12.9898,78.233)))*43758.5453)*2.0-0.8;
	//float scanline = sin(timer*100);
	//float scanline = 0.5;
	
	float scanline1 = (sin(10*timer+texCoord.t*1024)+1)*0.1;
	float scanline2 = (sin(2*timer+(texCoord.t+10)*10)+1)*0.1;
	
	vec4 inColor = texture2D(fboTexture,texCoord);

	/*
	float brightness = dot(cColor,vWeightsBW);
	OUT.color=brightness*vWeightsSepia;
	OUT.color.y += 0.3;
	*/
	brightness = dot(inColor,BW);
	inColor += vec4(scanline1*0.1,scanline1*0.15,scanline1*0.1,scanline1);
	//inColor += vec4(scanline2,0,0,0);
	//inColor= vec4(brightness,brightness,brightness,brightness)*Sepia;
	//inColor.y += 0.3;
	staticNoise *= staticNoiseAmmount;
	inColor.xyz += vec3(staticNoise*0.1,staticNoise*0.1,staticNoise*0.1);
	inColor.xyz += vec3(noise*0.1,noise*0.1,noise*0.1);
	
	if(fadeLevel < 1)
		inColor.xyz *= vec3(fadeLevel,fadeLevel,fadeLevel);
	
	gl_FragColor = inColor;
}
