float noise(vec2 pos,int seed);
float cosInterpolate(vec2 a, float x);
float smooth_2d_noise(vec2 pos,int seed);

float noise(vec2 pos,int seed) {
	float ret = fract(sin(seed+dot(pos,vec2(12.9898,78.233)))*43758.5453)*2.0-0.8;
	return ret;
}

float smooth_2d_noise(vec2 pos,int seed) {
	vec3 a = vec3(0,0,0);
	float ret;
	a.x = (noise(vec2(pos.x-1,pos.y-1),seed) + noise(vec2(pos.x+1,pos.y-1),seed) + noise(vec2(pos.x-1,pos.y+1),seed) + noise(vec2(pos.x+1,pos.y+1),seed)) / 16;
	a.y = (noise(vec2(pos.x-1,pos.y),seed) + noise(vec2(pos.x+1,pos.y),seed) + noise(vec2(pos.x,pos.y-1),seed) + noise(vec2(pos.x,pos.y+1),seed) ) / 8;
	a.z = noise(pos,seed)/4;
	ret = a.x + a.y + a.z;
	return ret;
}

float cosInterpolate(vec2 a, float x) {
	float ft,f,ret;
	float PI = 3.14159265358979323846264;
	ft = (x*PI);
	f = ((1-cos(ft)) * 0.5);
	ret = a.x*(1-f)+a.y*f;
	return ret;
}

float cos_2d_noise(vec2 pos, int seed) {
	vec2 int_pos = floor(pos);
	vec2 frac_pos = pos - int_pos;//fract(pos);
	float ret;
	vec4 v;
	vec2 i;
	
	v.x = smooth_2d_noise(int_pos,seed);	
	v.y = smooth_2d_noise(vec2(int_pos.x+1.0,int_pos.y),seed);
	v.z = smooth_2d_noise(vec2(int_pos.x,int_pos.y+1),seed);
	v.a = smooth_2d_noise(vec2(int_pos.x+1.0,int_pos.y+1.0),seed);
	
	i.x = cosInterpolate(vec2(v.x,v.y),frac_pos.x);
	i.y = cosInterpolate(vec2(v.z,v.a),frac_pos.x);
	
	ret = cosInterpolate(i,frac_pos.y);
	
	return ret;
}


float perlinNoise(vec2 pos,int seed) {
	int i;
	float ret = 0.0;
	float freq,amp;
	int p = 3;
	int n = 3;
	
	for(i=0;i<n;i++) {
		freq = pow(2,i);
		amp = pow(p,i);
		ret += cos_2d_noise(vec2(pos.x*freq,pos.y*freq),seed) *amp;
		ret += 0.1;
	}
	return ret;
}



uniform float timer;
varying vec3 pos;

/*
float makeNoise(vec3 pos) {
   float ret = 0.0f;
   pos *= vec3(0.25,0.25,0.25);
   ret = sin( 2*timer+(pos.x * pos.y * pos.z));
   return ret;
}
*/

void main() {
   gl_Position = ftransform();
   /*
   gl_Position.xyz += vec3(sin(timer+(gl_Position.x*gl_Position.y*gl_Position.z)*0.01),0.0,0.0);
   gl_Position.y += sin(timer+gl_Position.z*gl_Position.y *0.001)*2;
   //gl_Position.x += cos((timer * 0.8)+gl_Position.z*0.001)*2 + sin(timer * 0.3 + gl_Position.y*0.001)*0.5;
   gl_Position.x += sin(timer+(gl_Position.z*0.04))*5;
   gl_Position.xyz += vec3( sin( (5*timer)+(gl_Position.x*gl_Position.y*gl_Position.z*0.01))*0.5,0,0);
   */
   pos = gl_Position.xyz;
   //gl_Position.xyz += vec3(sin(timer+(gl_Position.x*gl_Position.y*gl_Position.z)*0.01),0.0,0.0);

   //gl_Position.xyz += vec3(0.3*makeNoise(pos),0.3*makeNoise(pos),0);

   gl_Position.y += sin( (2*timer+100)+ (gl_Position.z*0.06)  )*4;
   gl_Position.x += cos( (2*timer)+     (gl_Position.z*0.06)  )*4;
   pos = gl_Position.xyz;
}
